{$F+}
Unit SVGMouse; {- প   256-梥 SVGA ० }

interface

type
	ComData = record
  	IntrNum : Byte;
    PortNum : Word;
  end;

const
  ComParam : array [1..2] of ComData =
		((IntrNum: $0C; PortNum: $3F8), (IntrNum: $0B; PortNum: $3F8));

  RateX: Byte = 2; {- ⢨⥫쭮 .   祭, ⥬ }
  RateY: Byte = 2; {-   ⢨⥫쭠                        }

var
	LeftButton, RightButton : Boolean; {-  }
  CurMX, CurMY : Longint;            {- न }
  MouseVisible : Boolean;

  MouseCursor  : Pointer; {- 㪠⥫    }

  MinMouseX : Integer; {- ,  ஬   }
  MaxMouseX : Integer;
  MinMouseY : Integer;
  MaxMouseY : Integer;

  UserButtProc : procedure; {- ।塞 楤 짮⥫  }
  UserCoorProc : procedure; {- ࠡ⪨    न  }

procedure InitMouse(Comport: Byte); {- 樠 }
procedure DoneMouse;                {- 稫 ࠡ }

procedure SetMouseWindow(MinX, MinY, MaxX, MaxY: Integer);
{- ⠭ ࠭ ६饭  }
procedure AdjustMouse;              {-   ࠭ ࠭ }

procedure SetMouseCursor(Cursor: Pointer);  {- 짮⥫᪨  }
procedure SetDefaultCursor;                 {-   㬮砭     }

procedure ShowMouseCursor; {-   }
procedure HideMouseCursor; {-     }

implementation
uses Dos, Graph;
{$I SVGA_PUT.INC}

type
	PImgHeader = ^ImgHeader;
	ImgHeader = record
  	Width : Word;
    Height: Word;
  end;

var
	MousePort : Byte;
	bytenum : word;
  combytes : array[0..2] of byte;
  MouseHandler : procedure;
  SaveBuff     : Pointer;
  BuffSize     : PImgHeader;
  OldX, OldY   : LongInt;
  OldLB, OldRB : Boolean;
  DynaX, DynaY : Integer;

procedure DefCur; external;
{$L MICE.OBJ}

procedure SetMouseCursor(Cursor: Pointer);
begin
	if MouseCursor <> nil then
		FreeMem(SaveBuff, BuffSize^.Width * BuffSize^.Height);

  if MouseVisible then
  	PutImage(CurMX, CurMY, SaveBuff^, NormalPut);

  MouseCursor := Cursor;
  BuffSize := PImgHeader(MouseCursor);
  GetMem(SaveBuff, BuffSize^.Width * BuffSize^.Height);
  if MouseVisible then
  begin
  	GetImage(CurMX, CurMY,
			CurMX+BuffSize^.Width, CurMY+BuffSize^.Width, SaveBuff^);
  	PutImage(CurMX, CurMY, MouseCursor^, TRANS_COPY_PUT);
  end;
  AdjustMouse;
end;

procedure SetDefaultCursor;
begin
	SetMouseCursor(@DefCur);
end;

procedure ShowMouseCursor;
begin
	GetImage(CurMX, CurMY,
		CurMX+BuffSize^.Width, CurMY+BuffSize^.Width, SaveBuff^);
  PutImage(CurMX, CurMY, MouseCursor^, TRANS_COPY_PUT);
  MouseVisible := True;
end;

procedure HideMouseCursor;
begin
	PutImage(CurMX, CurMY, SaveBuff^, NormalPut);
  MouseVisible := False;
end;

procedure MyMouseHandler; Interrupt;
var dx, dy : integer;
    inbyte : byte;
begin

  { Get the port byte }
  inbyte := Port[ComParam[MousePort].PortNum];

  { Make sure we are properly "synched" }
  if (inbyte and 64) = 64 then bytenum := 0;

  { Store the byte and adjust bytenum }
  combytes[bytenum] := inbyte;
  inc(bytenum);

  { Have we received all 3 bytes? }
  if bytenum = 3 then
    begin
      { Yes, so process them }
      dx := (combytes[0] and 3) shl 6 + combytes[1];
      dy := (combytes[0] and 12) shl 4 + combytes[2];
      if dx >= 128 then dx := dx - 256;
      if dy >= 128 then dy := dy - 256;
      if (dx and $7FFF) > 2 then Inc(DynaX) else DynaX := 0;
      if DynaX > 2 then	DX := DX * RateX;
      if (DY and $7FFF) > 2 then Inc(DynaY) else DynaY := 0;
      if DynaY > 2 then	DY := DY * RateY;
      CurMX := CurMX + DX;
      CurMY := CurMY + DY;

      if CurMX < MinMouseX then CurMX := MinMouseX;
      if CurMX > MaxMouseX then CurMX := MaxMouseX;
      if CurMY < MinMouseY then CurMY := MinMouseY;
      if CurMY > MaxMouseY then CurMY := MaxMouseY;

      LeftButton  := (combytes[0] And 32) <> 0;
      RightButton := (combytes[0] And 16) <> 0;

      if (OldX <> CurMX) or (OldY <> CurMY) then
      begin
      	if MouseVisible then
        begin
        	PutImage(OldX, OldY, SaveBuff^, NormalPut);
          GetImage(CurMX, CurMY,
								CurMX+BuffSize^.Width, CurMY+BuffSize^.Width, SaveBuff^);
  				PutImage(CurMX, CurMY, MouseCursor^, TRANS_COPY_PUT);
        end;
        UserCoorProc;
      end;

      if (OldLB <> LeftButton) or (OldRB <> RightButton) then
      	UserButtProc;

      OldX := CurMX; OldY := CurMY;
      OldLB := LeftButton; OldRB := RightButton;

      { And start on first byte again }
      bytenum := 0;
    end;

  { Acknowledge the interrupt }
  Port[$20] := $20;
end;

procedure SetMouseWindow(MinX, MinY, MaxX, MaxY: Integer);
begin
	MinMouseX := MinX;
	MaxMouseX := MaxX;
  MinMouseY := MinY;
	MaxMouseY := MaxY;
end;

procedure AdjustMouse;
begin
  SetMouseWindow(1,1,GetMaxX-BuffSize^.Width, GetMaxY);
end;


procedure InitMouse(Comport: Byte);
begin
  MousePort := Comport;
  CurMX := 0;
  CurMY := 0;
  LeftButton  := False;
  RightButton := False;
  OldX:= 0; OldY:= 0;
  OldLB := False; OldRB := False;
  MouseVisible := False;
  DynaX := 0;
  { Save the current mouse handler and set up our own }
  GetIntVec(ComParam[MousePort].IntrNum, @MouseHandler);
  SetIntVec(ComParam[MousePort].IntrNum, Addr(MyMouseHandler));
  SetDefaultCursor;
end;

procedure DoneMouse;
begin
	if MouseCursor <> nil then
		FreeMem(SaveBuff, BuffSize^.Width * BuffSize^.Height);
  SetIntVec(ComParam[MousePort].IntrNum, @MouseHandler);
end;

procedure DummyProc;
begin
end;

begin
  MouseCursor := nil;
  UserCoorProc := DummyProc;
  UserButtProc := DummyProc;
end.